Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/ExperimentManagerClient.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/ExperimentManagerClient.cs	(revision 6004)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive/3.4/ExperimentManager/ExperimentManagerClient.cs	(revision 6006)
@@ -145,5 +145,9 @@
 
     public static void StartExperiment(Action<Exception> exceptionCallback, HiveExperiment hiveExperiment) {
-      ExperimentManagerClient.StoreAsync(exceptionCallback, hiveExperiment);
+      ExperimentManagerClient.StoreAsync(
+        new Action<Exception>((Exception ex) => {
+          hiveExperiment.ExecutionState = ExecutionState.Prepared;
+          exceptionCallback(ex);
+        }), hiveExperiment);
       hiveExperiment.ExecutionState = ExecutionState.Started;
     }
@@ -151,5 +155,5 @@
     public static void PauseExperiment(HiveExperiment hiveExperiment) {
       ServiceLocator.Instance.CallHiveService(service => {
-        foreach (HiveJob job in hiveExperiment.HiveJob.GetAllHiveJobs()) {
+        foreach (HiveJob job in hiveExperiment.GetAllHiveJobs()) {
           if (job.Job.State != JobState.Finished && job.Job.State != JobState.Aborted && job.Job.State != JobState.Failed)
             service.PauseJob(job.Job.Id);
@@ -161,5 +165,5 @@
     public static void StopExperiment(HiveExperiment hiveExperiment) {
       ServiceLocator.Instance.CallHiveService(service => {
-        foreach (HiveJob job in hiveExperiment.HiveJob.GetAllHiveJobs()) {
+        foreach (HiveJob job in hiveExperiment.GetAllHiveJobs()) {
           if (job.Job.State != JobState.Finished && job.Job.State != JobState.Aborted && job.Job.State != JobState.Failed)
             service.StopJob(job.Job.Id);
@@ -185,9 +189,16 @@
           }
 
-          hiveExperiment.HiveJob.SetIndexInParentOptimizerList(null);
-
-          int totalJobCount = hiveExperiment.HiveJob.GetAllHiveJobs().Count();
+          foreach (HiveJob hiveJob in hiveExperiment.HiveJobs) {
+            hiveJob.SetIndexInParentOptimizerList(null);
+          }
+
+          // upload HiveExperiment
+          hiveExperiment.Progress.Status = "Uploading HiveExperiment...";
+          hiveExperiment.Id = service.AddHiveExperiment(hiveExperiment);
+
+          int totalJobCount = hiveExperiment.GetAllHiveJobs().Count();
           int jobCount = 0;
 
+          // upload plugins
           hiveExperiment.Progress.Status = "Uploading plugins...";
           this.OnlinePlugins = service.GetPlugins();
@@ -196,11 +207,11 @@
           this.alreadyUploadedPlugins.Add(configFilePlugin);
 
+          // upload jobs
           hiveExperiment.Progress.Status = "Uploading jobs...";
-          UploadJobWithChildren(hiveExperiment.Progress, service, hiveExperiment.HiveJob, null, resourceIds, ref jobCount, totalJobCount, configFilePlugin.Id, hiveExperiment.UseLocalPlugins);
-          hiveExperiment.RootJobId = hiveExperiment.HiveJob.Job.Id;
-
-          // insert or update HiveExperiment
-          hiveExperiment.Progress.Status = "Uploading HiveExperiment...";
-          hiveExperiment.Id = service.AddHiveExperiment(hiveExperiment);
+
+          foreach (HiveJob hiveJob in hiveExperiment.HiveJobs) {
+            UploadJobWithChildren(hiveExperiment.Progress, service, hiveJob, null, resourceIds, ref jobCount, totalJobCount, configFilePlugin.Id, hiveExperiment.UseLocalPlugins, hiveExperiment.Id);
+          }
+
           if (hiveExperiment.RefreshAutomatically) hiveExperiment.StartResultPolling();
         });
@@ -239,5 +250,5 @@
     /// <param name="parentHiveJob">shall be null if its the root job</param>
     /// <param name="groups"></param>
-    private void UploadJobWithChildren(IProgress progress, IHiveService service, HiveJob hiveJob, HiveJob parentHiveJob, IEnumerable<Guid> groups, ref int jobCount, int totalJobCount, Guid configPluginId, bool useLocalPlugins) {
+    private void UploadJobWithChildren(IProgress progress, IHiveService service, HiveJob hiveJob, HiveJob parentHiveJob, IEnumerable<Guid> groups, ref int jobCount, int totalJobCount, Guid configPluginId, bool useLocalPlugins, Guid hiveExperimentId) {
       jobCount++;
       progress.Status = string.Format("Serializing job {0} of {1}", jobCount, totalJobCount);
@@ -259,4 +270,5 @@
       hiveJob.Job.PluginsNeededIds = PluginUtil.GetPluginDependencies(service, this.onlinePlugins, this.alreadyUploadedPlugins, plugins, useLocalPlugins);
       hiveJob.Job.PluginsNeededIds.Add(configPluginId);
+      hiveJob.Job.HiveExperimentId = hiveExperimentId;
 
       progress.Status = string.Format("Uploading job {0} of {1} ({2} kb)", jobCount, totalJobCount, jobData.Data.Count() / 1024);
@@ -270,5 +282,5 @@
 
       foreach (HiveJob child in hiveJob.ChildHiveJobs) {
-        UploadJobWithChildren(progress, service, child, hiveJob, groups, ref jobCount, totalJobCount, configPluginId, useLocalPlugins);
+        UploadJobWithChildren(progress, service, child, hiveJob, groups, ref jobCount, totalJobCount, configPluginId, useLocalPlugins, hiveExperimentId);
       }
     }
@@ -276,5 +288,5 @@
 
     #region Download Experiment
-    public static void LoadExperiment (HiveExperiment hiveExperiment) {
+    public static void LoadExperiment(HiveExperiment hiveExperiment) {
       hiveExperiment.Progress = new Progress();
       try {
@@ -286,5 +298,5 @@
         // fetch all Job objects to create the full tree of tree of HiveJob objects
         hiveExperiment.Progress.Status = "Downloading list of jobs...";
-        allJobs = ServiceLocator.Instance.CallHiveService(s => s.GetLightweightChildJobs(hiveExperiment.RootJobId, true, true));
+        allJobs = ServiceLocator.Instance.CallHiveService(s => s.GetLightweightExperimentJobs(hiveExperiment.Id));
         totalJobCount = allJobs.Count();
 
@@ -299,25 +311,29 @@
         IDictionary<Guid, HiveJob> allHiveJobs = downloader.Results;
 
-        hiveExperiment.HiveJob = allHiveJobs[hiveExperiment.RootJobId];
-
-        if (hiveExperiment.HiveJob.Job.DateFinished.HasValue && hiveExperiment.HiveJob.Job.DateCreated.HasValue) {
-          hiveExperiment.ExecutionTime = hiveExperiment.HiveJob.Job.DateFinished.Value - hiveExperiment.HiveJob.Job.DateCreated.Value;
+        hiveExperiment.HiveJobs = new ItemCollection<HiveJob>(allHiveJobs.Values.Where(x => !x.Job.ParentJobId.HasValue));
+        //hiveExperiment.HiveJobs = allHiveJobs[hiveExperiment.RootJobId];
+
+        if (hiveExperiment.IsFinished()) {
+          //hiveExperiment.ExecutionTime = hiveExperiment.HiveJobs.Max(.Job.DateFinished.Value - hiveExperiment.HiveJobs.Job.DateCreated.Value;
           //hiveExperiment.lastUpdateTime = hiveExperiment.HiveJob.Job.DateFinished.Value;
           hiveExperiment.ExecutionState = Core.ExecutionState.Stopped;
           //OnStopped(); // todo: stop timer
         } else {
-          hiveExperiment.ExecutionTime = hiveExperiment.HiveJob.Job.DateCreated.HasValue ? DateTime.Now - hiveExperiment.HiveJob.Job.DateCreated.Value : TimeSpan.Zero;
+          //hiveExperiment.ExecutionTime = hiveExperiment.HiveJobs.Job.DateCreated.HasValue ? DateTime.Now - hiveExperiment.HiveJobs.Job.DateCreated.Value : TimeSpan.Zero;
           //hiveExperiment.lastUpdateTime = DateTime.Now;
           hiveExperiment.ExecutionState = Core.ExecutionState.Started;
           //OnStarted(); // todo: start timer
         }
+        hiveExperiment.UpdateTotalExecutionTime();
 
         // build child-job tree
-        BuildHiveJobTree(hiveExperiment.HiveJob, allJobs, allHiveJobs);
+        foreach (HiveJob hiveJob in hiveExperiment.HiveJobs) {
+          BuildHiveJobTree(hiveJob, allJobs, allHiveJobs);
+        }
         hiveExperiment.UpdateTotalExecutionTime();
 
         if (hiveExperiment.ExecutionState != ExecutionState.Stopped) {
           hiveExperiment.RefreshAutomatically = true;
-        }        
+        }
       }
       finally {
